3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] --resolved
10 git am [options] --skip
12 d,dotest= (removed -- do not use)
13 i,interactive run interactively
14 b,binary pass --allow-binary-replacement to git-apply
15 3,3way allow fall back on 3way merging if needed
16 s,signoff add a Signed-off-by line to the commit message
17 u,utf8 recode into utf8 (default)
18 k,keep pass -k flag to git-mailinfo
19 whitespace= pass it through git-apply
20 C= pass it through git-apply
21 p= pass it through git-apply
22 resolvemsg= override error message when patch failure occurs
23 r,resolved to be used after a patch failure
24 skip skip the current patch
25 rebasing (internal use for git-rebase)"
28 prefix
=$
(git rev-parse
--show-prefix)
33 git var GIT_COMMITTER_IDENT
>/dev
/null ||
34 die
"You need to set your committer info first"
37 echo "$1" >"$dotest/next"
41 stop_here_user_resolve
() {
42 if [ -n "$resolvemsg" ]; then
43 printf '%s\n' "$resolvemsg"
46 cmdline
=$
(basename $0)
47 if test '' != "$interactive"
51 if test '' != "$threeway"
55 echo "When you have resolved this problem run \"$cmdline --resolved\"."
56 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
62 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
63 "$dotest/patch" "$dotest/info"
64 echo "$next" >"$dotest/next"
70 echo "Cannot fall back to three-way merge."
75 O_OBJECT
=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
77 rm -fr "$dotest"/patch-merge-
*
78 mkdir
"$dotest/patch-merge-tmp-dir"
80 # First see if the patch records the index info that we can use.
81 git apply
--build-fake-ancestor "$dotest/patch-merge-tmp-index" \
83 GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
84 git write-tree
>"$dotest/patch-merge-base+" ||
85 cannot_fallback
"Repository lacks necessary blobs to fall back on 3-way merge."
87 echo Using index info to reconstruct a base tree...
88 if GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
89 git apply
$binary --cached <"$dotest/patch"
91 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
92 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
94 cannot_fallback
"Did you hand edit your patch?
95 It does not apply to blobs recorded in its index."
98 test -f "$dotest/patch-merge-index" &&
99 his_tree
=$
(GIT_INDEX_FILE
="$dotest/patch-merge-index" git write-tree
) &&
100 orig_tree
=$
(cat "$dotest/patch-merge-base") &&
101 rm -fr "$dotest"/patch-merge-
* ||
exit 1
103 echo Falling back to patching base and
3-way merge...
105 # This is not so wrong. Depending on which base we picked,
106 # orig_tree may be wildly different from ours, but his_tree
107 # has the same set of wildly different changes in parts the
108 # patch did not touch, so recursive ends up canceling them,
109 # saying that we reverted all those changes.
111 eval GITHEAD_
$his_tree='"$FIRSTLINE"'
112 export GITHEAD_
$his_tree
113 git-merge-recursive
$orig_tree -- HEAD
$his_tree ||
{
115 echo Failed to merge
in the changes.
118 unset GITHEAD_
$his_tree
122 dotest
="$GIT_DIR/rebase"
123 sign
= utf8
=t keep
= skip
= interactive
= resolved
= binary
= rebasing
=
139 utf8
=t
;; # this is now default
149 rebasing
=t threeway
=t keep
=t binary
=t
;;
151 die
"-d option is no longer supported. Do not use."
154 shift; resolvemsg
=$1 ;;
156 git_apply_opt
="$git_apply_opt $1=$2"; shift ;;
158 git_apply_opt
="$git_apply_opt $1$2"; shift ;;
167 # If the dotest directory exists, but we have finished applying all the
168 # patches in them, clear it out.
169 if test -d "$dotest" &&
170 last
=$
(cat "$dotest/last") &&
171 next
=$
(cat "$dotest/next") &&
173 test "$next" -gt "$last"
180 case "$#,$skip$resolved" in
182 # Explicit resume command and we do not have file, so
186 # No file input but without resume parameters; catch
187 # user error to feed us a patch from standard input
188 # when there is already $dotest. This is somewhat
189 # unreliable -- stdin could be /dev/null for example
190 # and the caller did not intend to feed us a patch but
191 # wanted to continue unattended.
198 die
"previous rebase directory $dotest still exists but mbox given."
201 # Make sure we are not given --skip nor --resolved
202 test ",$skip,$resolved," = ,,, ||
203 die
"Resolve operation not in progress, we are not resuming."
206 mkdir
-p "$dotest" ||
exit
208 if test -n "$prefix" && test $# != 0
213 test -n "$first" && {
221 set "$@" "$prefix$arg" ;;
226 git mailsplit
-d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
{
231 # -b, -s, -u, -k and --whitespace flags are kept for the
232 # resuming session after a patch failure.
233 # -3 and -i can and must be given when resuming.
234 echo "$binary" >"$dotest/binary"
235 echo " $ws" >"$dotest/whitespace"
236 echo "$sign" >"$dotest/sign"
237 echo "$utf8" >"$dotest/utf8"
238 echo "$keep" >"$dotest/keep"
239 echo 1 >"$dotest/next"
240 if test -n "$rebasing"
242 : >"$dotest/rebasing"
244 : >"$dotest/applying"
245 git update-ref ORIG_HEAD HEAD
251 files
=$
(git diff-index
--cached --name-only HEAD
--) ||
exit
252 if [ "$files" ]; then
253 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
258 if test "$(cat "$dotest/binary
")" = t
260 binary
=--allow-binary-replacement
262 if test "$(cat "$dotest/utf8
")" = t
268 if test "$(cat "$dotest/keep
")" = t
272 ws
=`cat "$dotest/whitespace"`
273 if test "$(cat "$dotest/sign
")" = t
275 SIGNOFF
=`git-var GIT_COMMITTER_IDENT | sed -e '
277 s/^/Signed-off-by: /'
283 last
=`cat "$dotest/last"`
284 this
=`cat "$dotest/next"`
288 this
=`expr "$this" + 1`
292 if test "$this" -gt "$last"
299 while test "$this" -le "$last"
301 msgnum
=`printf "%0${prec}d" $this`
302 next
=`expr "$this" + 1`
303 test -f "$dotest/$msgnum" ||
{
309 # If we are not resuming, parse and extract the patch information
310 # into separate files:
311 # - info records the authorship and title
312 # - msg is the rest of commit log message
313 # - patch is the patch body.
315 # When we are resuming, these files are either already prepared
316 # by the user, or the user can tell us to do so by --resolved flag.
319 git mailinfo
$keep $utf8 "$dotest/msg" "$dotest/patch" \
320 <"$dotest/$msgnum" >"$dotest/info" ||
323 # skip pine's internal folder data
324 grep '^Author: Mail System Internal Data$' \
325 <"$dotest"/info
>/dev
/null
&&
328 test -s "$dotest/patch" ||
{
329 echo "Patch is empty. Was it split wrong?"
332 if test -f "$dotest/rebasing" &&
333 commit
=$
(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
334 -e q
"$dotest/$msgnum") &&
335 test "$(git cat-file -t "$commit")" = commit
337 git cat-file commit
"$commit" |
338 sed -e '1,/^$/d' >"$dotest/msg-clean"
340 SUBJECT
="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info
")"
341 case "$keep_subject" in -k) SUBJECT
="[PATCH] $SUBJECT" ;; esac
343 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
344 git stripspace
> "$dotest/msg-clean"
349 GIT_AUTHOR_NAME
="$(sed -n '/^Author/ s/Author: //p' "$dotest/info
")"
350 GIT_AUTHOR_EMAIL
="$(sed -n '/^Email/ s/Email: //p' "$dotest/info
")"
351 GIT_AUTHOR_DATE
="$(sed -n '/^Date/ s/Date: //p' "$dotest/info
")"
353 if test -z "$GIT_AUTHOR_EMAIL"
355 echo "Patch does not have a valid e-mail address."
359 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
363 if test '' != "$SIGNOFF"
366 sed -ne '/^Signed-off-by: /p' \
367 "$dotest/msg-clean" |
371 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
372 test '' = "$LAST_SIGNED_OFF_BY" && echo
379 if test -s "$dotest/msg-clean"
381 cat "$dotest/msg-clean"
383 if test '' != "$ADD_SIGNOFF"
387 } >"$dotest/final-commit"
390 case "$resolved$interactive" in
392 # This is used only for interactive view option.
393 git diff-index
-p --cached HEAD
-- >"$dotest/patch"
399 if test "$interactive" = t
402 die
"cannot be interactive without stdin connected to a terminal."
404 while test "$action" = again
406 echo "Commit Body is:"
407 echo "--------------------------"
408 cat "$dotest/final-commit"
409 echo "--------------------------"
410 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
414 [aA
]*) action
=yes interactive
= ;;
415 [nN
]*) action
=skip
;;
416 [eE
]*) git_editor
"$dotest/final-commit"
419 LESS
=-S ${PAGER:-less} "$dotest/patch" ;;
426 FIRSTLINE
=$
(sed 1q
"$dotest/final-commit")
428 if test $action = skip
434 if test -x "$GIT_DIR"/hooks
/applypatch-msg
436 "$GIT_DIR"/hooks
/applypatch-msg
"$dotest/final-commit" ||
440 printf 'Applying %s\n' "$FIRSTLINE"
444 git apply
$git_apply_opt $binary --index "$dotest/patch"
448 # Resolved means the user did all the hard work, and
449 # we do not have to do any patch application. Just
450 # trust what the user has in the index file and the
453 git diff-index
--quiet --cached HEAD
-- && {
454 echo "No changes - did you forget to use 'git add'?"
455 stop_here_user_resolve
$this
457 unmerged
=$
(git ls-files
-u)
458 if test -n "$unmerged"
460 echo "You still have unmerged paths in your index"
461 echo "did you forget to use 'git add'?"
462 stop_here_user_resolve
$this
469 if test $apply_status = 1 && test "$threeway" = t
473 # Applying the patch to an earlier tree and merging the
474 # result may have produced the same tree as ours.
475 git diff-index
--quiet --cached HEAD
-- && {
476 echo No changes
-- Patch already applied.
480 # clear apply_status -- we have successfully merged.
484 if test $apply_status != 0
486 echo Patch failed
at $msgnum.
487 stop_here_user_resolve
$this
490 if test -x "$GIT_DIR"/hooks
/pre-applypatch
492 "$GIT_DIR"/hooks
/pre-applypatch || stop_here
$this
495 tree
=$
(git write-tree
) &&
496 parent
=$
(git rev-parse
--verify HEAD
) &&
497 commit
=$
(git commit-tree
$tree -p $parent <"$dotest/final-commit") &&
498 git update-ref
-m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD
$commit $parent ||
501 if test -x "$GIT_DIR"/hooks
/post-applypatch
503 "$GIT_DIR"/hooks
/post-applypatch